/* mailform.cgi.c - CGI program that parses comments form, and mails
      delimited information to appropriate user
   Eugene Kim, eekim@fas.harvard.edu
   $Id: mailform.cgi.c,v 1.1 1995/06/23 06:47:19 eekim Exp $

   Copyright (C) 1995 Eugene Eric Kim
   All Rights Reserved
*/

#include <stdio.h>
#include <signal.h>
#include <unistd.h>
#include <string.h>
#include "cgi-lib.h"
#include "html-lib.h"

#define WEBADMIN "web@deist.student.harvard.edu"
#define AUTH "/home/web/httpd/conf/mail.conf"
#define DELIMITER ","
#define subject "Submitted Form - from web server"

void authenticate(char *dest)
{
  FILE *access;
  char s[80];
  short FOUND = 0;

  access = fopen(AUTH,"r");
  while ( (fgets(s,80,access)!=NULL) && (!FOUND) ) {
    s[strlen(s) - 1] = '\0';
    if (!strcmp(s,dest))
      FOUND = 1;
  }
  if (!FOUND) {
    /* not authenticated */
    html_begin("Unauthorized Destination");
    printf("<h1>Unauthorized Destination</h1>\r\n");

    html_end();
    exit(1);
  }
}

int main()
{
  llist entries;
  node* window;
  FILE *mail;
  char dest[80];
  char command[256] = "/usr/lib/sendmail ";
  char name[MAX_VALUE_LENGTH],email[MAX_VALUE_LENGTH];

  signal(SIGALRM, die);
  alarm(30); /* die if processing isn't done in 30 seconds */
  PrintHeader();
  ReadParse(&entries);
  strcpy(dest,val(entries,"to"));
  strcpy(name,val(entries,"name"));
  strcpy(email,val(entries,"email"));
  if (dest[0]=='\0')
    strcpy(dest,WEBADMIN);
  else
    authenticate(dest);
  strcat(command,dest);
  mail = popen(command,"w");
  if (mail == NULL) {
    html_begin("System Error!");
    printf("<h1>System Error!</h1>\r\n<hr>\r\n");
    printf("Please mail %s and inform\r\n",WEBADMIN);
    printf("the web maintainers that the comments script is improperly\r\n");
    printf("configured. We apologize for the inconvenience<p>\r\n");
    printf("<hr>\r\nWeb page created on the fly by ");
    printf("<i>%s</i>.\r\n",WEBADMIN);
    html_end();
    exit(1);
  }
  else {
    fprintf(mail,"From: %s (%s)\n",email,name);
    fprintf(mail,"Subject: %s\n",subject);
    fprintf(mail,"To: %s\n",dest);
    fprintf(mail,"Sent-By: %s\n\n",WEBADMIN);
    window = entries.head;
    while (window != 0) {
      if (strcmp("to",(*window).entry.name) &&
	  strcmp("subject",(*window).entry.name) ) {
	fprintf(mail,"%s",(*window).entry.value);
	if ( (*window).next != 0)
	  fprintf(mail,"%s",DELIMITER);
	else
	  fprintf(mail,"\n");
      }
      window = (*window).next;
    }
    pclose(mail);
    html_begin("Data Submitted");
    printf("<h1>Data Submitted</h1>\r\n");
    printf("The following data has been submitted:<p>\r\n");
    window = entries.head;
    printf("<dl>\r\n");
    while (window != 0) {
      if (strcmp("to",(*window).entry.name) &&
	  strcmp("subject",(*window).entry.name) ) {
	printf("<dt> %s\r\n",(*window).entry.name);
	printf("<dd> %s\r\n",(*window).entry.value);
      }
      window = (*window).next;
    }
    printf("</dl>\r\n");
    printf("<hr>\r\nWeb page created on the fly by ");
    printf("<i>%s</i>.\r\n",WEBADMIN);
    html_end();
    exit(0);
  }
  list_clear(&entries);
  exit(0);
}
